<%= File.read(File.join File.dirname(__FILE__), 'header.html.erb') %>

<% if @user %>

<div id="player-logout">
  <p><%= @user.email %> <a href="/overview/logout">logout</a></p>
</div>

<div class="stats-container">
  <div class="table-div">
    <h5 id="stats">Stats</h5>
    <table id="" class="table stable-inverse">
      <thead>
        <tr class="header">
          <td>Resource</td>
          <td>Count</td>
          <td></td>
        </tr>
      </thead>
      <tbody>
        <% %w(metal fiber petrol).each do |resource| %>
        <tr>
          <td><%= resource %> </td>
          <td id="<%= resource %>-count"><%= @user.send(resource) %></td>
          <td></td>
        </tr>
        <% end %>
      </tbody>
    </table>
  </div>
</div>

<div class="buttons-div">
  <!-- <button class="btn btn-sm btn-outline-secondary btn-small" onclick="buildTrailers();">Build 10 trailer trucks</button> -->
  <a href="/overview" class="btn btn-sm btn-outline-secondary btn-small">Go to dashboard</a>
</div>

<% %w(trailers factories hubs warehouses).each do |resource| %>
<div class="table-div">
  <!-- <button onlcick="showTable(<%=resource%>,this);"></button> -->
  <button class="btn resource-btn" onclick="showTable('<%= resource %>', this)">&#9650; Browse <%= resource %></button>

  <table id="<%= resource %>-table-header" class="table stable-inverse d-none">
    <thead>
      <tr>
        <% unless resource == 'trailers'%>
          <td>Level</td>
        <% end %>
        <td>Metal</td>
        <td>Fiber</td>
        <td>Petrol</td>
        <td>Actions</td>
      </tr>
    </thead>
  </table>
<div class="scrollable">
  <table id="<%= resource %>-table" class="table stable-inverse d-none">
    <tbody>
      <% instance_variable_get("@#{resource}").each do |r| %>
      <tr id="<%= r.id %>">
        <% unless resource == 'trailers'%>
          <td><%= r.level %></td>
        <% end %>
        <td><%= r.sale_metal %></td>
        <td><%= r.sale_fiber %></td>
        <td><%= r.sale_petrol %></td>
        <td>
          <button class="btn btn-sm btn-outline-secondary btn-small"
                  data-resource="<%= resource %>"
                  data-id="<%= r.id %>"
                  data-metal="<%= r.sale_metal %>"
                  data-fiber="<%= r.sale_fiber %>"
                  data-petrol="<%= r.sale_petrol %>"
                  onclick="buyResource(this);">buy</button>
        </td>
      </tr>
      <% end %>
    </tbody>
  </table>
</div>
</div>
<% end %>

</div>  <!-- /container -->

<style media="screen">
.content *{
  font-size: 0.97em;
}
.content {
  padding: 20px 20px 20px 20px;
}
.table-div {
  border: 1px solid rgba(0,0,0,.1);
  padding: 5px 5px 5px 5px;
  margin: 5px 5px 5px 5px;
}
.scrollable {
  overflow-y: scroll;
  /* height: 100%; */
  max-height: 230px;
}
.resource-btn {
  width: 200px;
  text-align: left;
  padding: 0px 0px 0px 5px;
  margin: 0;
  color: grey;
  background-color: transparent;
}

td {
  width: 20% !important;
}

thead > tr > td {
  font-weight: bold;
  border-top: 0px solid rgba(0,0,0,.0) !important;
}

tbody > tr > td {
  padding: 5px 5px 5px 12px !important;
}

thead > tr {
  border-top: 0px solid rgba(0,0,0,.0) !important;
}
#trailers-table-header, #warehouses-table-header, #hubs-table-header, #factories-table-header{
  border-top: 1px solid rgba(0,0,0,.0) !important;
  border-bottom: 1px solid rgba(0,0,0,.5) !important;
  margin-bottom: 0;
}

#stats {
  margin: 10px 10px 10px 10px;
  color: grey;
}
#player-logout {
  margin: 10px 10px 10px 10px;
  color: grey;
}
.header {
  border-top: 1px solid rgba(0,0,0,.0) !important;
  border-bottom: 1px solid rgba(0,0,0,.5) !important;
  font-weight: bold;
}
.buttons-div {
  padding: 10px 5px 10px 5px;
}
</style>

<script>
  function showTable(resource, el) {
    var table = document.getElementById(resource + '-table')
    var header = document.getElementById(resource + '-table-header')
    if (table.classList.contains('d-none')) {
      table.classList.remove('d-none');
      header.classList.remove('d-none');
      el.innerHTML = '&#9660; Browse ' + resource;
    } else {
      table.classList.add('d-none');
      header.classList.add('d-none');
      el.innerHTML = '&#9650; Browse ' + resource;
    }
  }

  function updateStatsSuccess(data) {
    document.getElementById('metal-count').innerHTML = data.metal;
    document.getElementById('fiber-count').innerHTML = data.fiber;
    document.getElementById('petrol-count').innerHTML = data.petrol;
  }

  function buyResource(el) {
    var msg = 'Confirm purchase\n';
    msg += 'metal: '+el.dataset.metal+'\n';
    msg += 'fiber: '+el.dataset.fiber+'\n';
    msg += 'petrol: '+el.dataset.petrol;
    if (confirm(msg)) {
      var id = el.dataset.id;
      var resource = el.dataset.resource;
      $.ajax({
        type: 'PUT',
        url: '../../'+resource+'/'+id+'/buy',
        contentType: 'application/json',
        headers: { 'X-User-Token' : getCookie('userAuthToken') },
        success: function() { location.reload(); },
        error: function(data) {
          var message = ''
          for (var err in data.responseJSON.errors) {
            message += err +': '+data.responseJSON.errors[err][0]+'\n'
          }
          alert(message);
        }
      });
    }
  }

  function updateStats() {
    $.ajax({
      type: 'GET',
      url: '../../current_user',
      contentType: 'application/json',
      headers: { 'X-User-Token' : getCookie('userAuthToken') },
      success: updateStatsSuccess
    });
  }

  function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
  }

  window.onload = function() {
    setInterval(function(){ updateStats(); }, 5000);
  }
</script>

<% else %>
 <script type="text/javascript">
   window.onload = function() {
     window.location.href = "/overview/login";
   }
 </script>
<% end %>

<%= File.read(File.join File.dirname(__FILE__), 'footer.html.erb') %>
